package com.HybridServerPages;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.io.Writer;

final public class TestRunner {
static public void main(String[] args){
    //U.findASPackage(U.pojos_dir);
    runTests(null);
} // main

private static void testPage(File page_file){
    String pack = U.getPackageByFile(new File("pages"),page_file);
    String pn = U.getShortNameNoExt(page_file);
    String cmd = null;
    String pf = System.getenv("ProgramFiles(x86)");
    if(pf == null)
        pf = System.getenv("ProgramFiles");
    if(pack != null){
        pn = pack + '.' + pn;
    }// if
    String class_file_name = "classes" + File.separatorChar
            + pn.replace('.',File.separatorChar) + "_P.class";
    System.out.println("Running page " + pn);
    if(!new File(class_file_name).exists())
        return;
    String output_file_name = pn.replace('.','_') + ".html";
    File of = new File(output_file_name);
    PrintWriter pw = null;
    HJHttpServletRequest req = new HJHttpServletRequest();
    try{
        //ps = new PrintStream(,false,"UTF-8");
        OutputStream os = new FileOutputStream(of);
        Writer w = new OutputStreamWriter(os,"UTF-8");
        req.pw = new PrintWriter(w);
        pw = req.pw;
    }catch(FileNotFoundException ex){
        rt.$renderError(ex,pn,null,true, -1);
    }catch (java.io.UnsupportedEncodingException ex){
        rt.$renderError(ex,pn,null,true, -1);
    }
    try{
        BasePage state = rt.getPageInstance(pn + "_P",req,null,null);
        state.$render(pw);
        System.out.println("page " + output_file_name + " generated");
        pw.flush();
        pw.close();
        //output_file_name = U.working_dir.getAbsolutePath() + File.separatorChar
        //        + output_file_name;
        cmd = pf + "\\Internet Explorer\\iexplore.exe " + output_file_name;
        cmd = "rundll32 url.dll,FileProtocolHandler " + output_file_name;
        System.err.println(cmd);
        Runtime.getRuntime().exec(cmd);
    }catch(Throwable ex){
        rt.$renderError(ex,pn,pw,true, -1);
    }// try
} // testPage(}

private static void runTests(File dir){
    // finds all the pages and runs the tests
    if(dir == null){
        dir = new File("pages");
    }// if
    File current_dir = new File(".");
    String p = current_dir.getAbsoluteFile().toString();
    System.err.println(current_dir);
    File[] list = dir.listFiles(new MyFileFilter(MyFileFilter.PAGE));
    for(int i = 0;i < list.length;i++){
        U.initU();
        testPage(list[i]);
    } // for pages
    // now go to all the sub-directories
    list = dir.listFiles(new MyFileFilter(MyFileFilter.DIR));
    for(int i = 0;i < list.length;i++){
        runTests(list[i]); // recursion
    }// for directories
} // runTests()

} // class
